package org.bitbucket.bradleysmithllc.etlunit.feature.informatica;

import org.bitbucket.bradleysmithllc.etlagent.informatica.provider.InformaticaDomain;
import org.bitbucket.bradleysmithllc.etlunit.RuntimeSupport;
import org.bitbucket.bradleysmithllc.etlunit.io.FileBuilder;

import javax.inject.Inject;
import java.io.File;

public class InformaticaRuntimeSupportImpl implements InformaticaRuntimeSupport
{
	private RuntimeSupport runtimeSupport;

	@Inject
	public void setRuntimeSupport(RuntimeSupport runtimeSupport)
	{
		this.runtimeSupport = runtimeSupport;
	}

	public File getInformaticaSourceDirectory()
	{
		return runtimeSupport.getFeatureSourceDirectory("informatica");
	}

	public File getInformaticaSourceDirectory(String folder)
	{
		return new FileBuilder(getInformaticaSourceDirectory()).subdir(folder).mkdirs().file();
	}

	public File getInformaticaWorkflowParameterDirectory(String folder)
	{
		return new FileBuilder(getInformaticaSourceDirectory(folder)).subdir("ParameterFiles").mkdirs().file();
	}

	public File getInformaticaWorkflow(String folder, String workflowName)
	{
		return new FileBuilder(getInformaticaSourceDirectory(folder)).name(workflowName + ".xml").file();
	}

	public File getInformaticaWorkflowParameterTemplate(String folder, String workflowName)
	{
		return new FileBuilder(getInformaticaWorkflowParameterDirectory(folder)).name(workflowName + ".PRM").file();
	}

	public File getSrcFilesRemote(InformaticaDomain domain)
	{
		return domain.getSourceFilesDir();
	}

	public File getLkpFilesRemote(InformaticaDomain domain)
	{
		return domain.getLookupFilesDir();
	}

	public File getTgtFilesRemote(InformaticaDomain domain)
	{
		return domain.getTargetFilesDir();
	}

	public File getBadFilesRemote(InformaticaDomain domain)
	{
		return domain.getBadFilesDir();
	}

	public File getLogFilesRemote(InformaticaDomain domain)
	{
		return domain.getSessionLogDir();
	}

	public File getParmFilesRemote(InformaticaDomain domain)
	{
		return domain.getParameterFilesDir();
	}
}